/*
   This file provides practice with manipulating binary tree nodes.

   Visualize your code with the jGRASP IDE.
*/

class Node<E> // Generic binary tree node.
{
   public E data;
   public Node<E> left;
   public Node<E> right;

   public Node(E data, Node<E> left, Node<E> right)
   {
      this.data = data;
      this.left = left;
      this.right = right;
   }

   public Node(E data) // Leaf node constructor.
   {
      this.data = data;
      this.left = null;
      this.right = null;
   }

   @Override public String toString()
   {
      return (null==left && null==right)? "" + data :
             "(" + data + ", "
                 + ((null ==  left)? "()" :  left.toString()) + ", "  // recursion
                 + ((null == right)? "()" : right.toString()) + ")";  // recursion
   }
}


/**
   Follow the directions below to implement a
   number of different binary tree manipulations.
*/
public class BinaryTreeNodesManipulations
{
   public static void main(String[] args)
   {
      /*
         1.) Write a single line of code that
             builds the following binary tree.
             Call it tree1.

              3
             / \
            5   6
           / \
          7   8
      */
      Node<Integer> tree1 = new Node<>(3,
                                       new Node<>(5,
                                                  new Node<>(7),
                                                  new Node<>(8)),
                                       new Node<>(6));
      System.out.println( tree1 );

      /*
         2.) Write a single line of code that modifies
             tree1 to be the following tree.

              3
             / \
            9   6
             \
              5
             / \
            7   8
      */
      tree1.left = new Node<>(9, null, tree1.left);
      System.out.println( tree1 );

      /*
         3.) Start with the following binary tree.

              3
             / \
            5   6
               / \
              7   8
      */
      Node<Integer> tree2 = new Node<>(3,
                                       new Node<>(5),
                                       new Node<>(6,
                                                  new Node<>(7),
                                                  new Node<>(8)));
      System.out.println( tree2 );

      /*
         Write a single line of code that modifies
         tree2 to be the following tree.

              3
             / \
            5   7
                 \
                  8
      */
      tree2.right = new Node<>(tree2.right.left.data,
                               null,
                               tree2.right.right);
      System.out.println( tree2 );

      /*
         4.) Write a single line of code that builds this binary tree.
             Call it tree3.

                1
               /
              2
             /
            3
           /
          4
      */
      Node<Integer> tree3 = new Node<>(1,
                                       new Node<>(2,
                                                  new Node<>(3,
                                                             new Node<>(4),
                                                             null),
                                                  null),
                                       null);
      System.out.println( tree3 );

      /*
         5.) Write a single line of code that builds this binary tree.
             Call it tree4.

                1
                 \
                  2
                   \
                    3
                     \
                      4
      */
      Node<Integer> tree4 = new Node<>(1,
                                       null,
                                       new Node<>(2,
                                                  null,
                                                  new Node<>(3,
                                                             null,
                                                             new Node<>(4))));
      System.out.println( tree4 );
   }
}
