/*
   Visualize this simple binary tree program
   with either the Java Visualizer web site,

      https://cscircles.cemc.uwaterloo.ca/java_visualize/

   or with the jGRASP IDE,

      https://www.jgrasp.org/
*/

class Node<E> // Generic binary tree node.
{
   private E data;
   public  Node<E> left;
   public  Node<E> right;

   public Node(E data, Node<E> left, Node<E> right)
   {
      this.data = data;
      this.left = left;
      this.right = right;
   }

   @Override public String toString()
   {
      return (null==left && null==right)? "" + data :
             "(" + data + ", "
                 + ((null ==  left)? "()" :  left.toString()) + ", "  // recursion
                 + ((null == right)? "()" : right.toString()) + ")";  // recursion
   }
}


public class BinaryTree_1
{
   public static void main(String[] args)
   {
      // Build a binary tree from the top down.
      Node<Integer> root = new Node<>(5,
                                      new Node<>(4,
                                                 new Node<>(3, null, null),
                                                 new Node<>(2, null, null)),
                                      new Node<>(6,
                                                 new Node<>(7,
                                                            new Node<>(9, null, null),
                                                            new Node<>(10, null, null)),
                                                 new Node<>(8, null, null)));
      System.out.println( root );
   }
}
/*
        5
       / \
      /   \
     /     \
    4       6
   / \     / \
  3   2   7   8
         / \
        9   10
*/
